const sortOrderList = () => {
  var ul = jQuery("#sitemap-order");
  var arr = jQuery.makeArray(ul.children("li"));

  arr.sort(function (a, b) {
    var textA = a.value;
    var textB = b.value;

    if (textA < textB) return -1;
    if (textA > textB) return 1;

    return 0;
  });

  ul.empty();

  jQuery.each(arr, function () {
    ul.append(this);
  });
}

const eventNeedToUpdateOrderList = new Event('click5_sitemap_force_order_list_update');

const relocateSubItems = () => {
  document.querySelectorAll('#sitemap-order > li > ol li').forEach(subli => {
    if(subli.hasAttribute('name')) {
      let newLocation = subli.getAttribute('name');
      if (subli.parentElement.parentElement) {
        if (subli.parentElement.parentElement.hasAttribute('data-value')) {
          if (newLocation !== subli.parentElement.parentElement.getAttribute('data-value')) {
            //document.querySelector('#sitemap-order li[data-value="' + newLocation + '"] > ol').append(subli);
          }
        }
      }

    }
  });
}

const sortSubOrderList = () => {
  document.querySelectorAll('#sitemap-order > li ol').forEach(ol => {
    var ul = jQuery(ol);
    var arr = jQuery.makeArray(ul.children("li"));

    arr.sort(function (a, b) {
      var textA = a.value;
      var textB = b.value;

      if (textA < textB) return -1;
      if (textA > textB) return 1;

      return 0;
    });

    ul.empty();

    jQuery.each(arr, function () {
      ul.append(this);
    });
  })
}

const sortListByCurrentSortData = () => {
  getRequest('/wp-json/click5_sitemap/API/get_sitemap_order', (data) => {
    if (data) {
      if(data.length) {
        data.forEach(sortObject => {
          sortElement = document.querySelector('li[data-value="'+sortObject.ID+'"]');
          if(sortElement) {
            sortElement.setAttribute('value', sortObject.order);
            if (sortObject.parent) {
              sortElement.setAttribute('name', sortObject.parent);
            }
          }
        });
        sortOrderList();
        relocateSubItems();
        sortSubOrderList();

        //console.log('loaded');
        jQuery("#btnSaveOrder").trigger('click');
      }
    }
  });
}

const loadOrderList = (callback = undefined) => {
  getRequest('/wp-json/click5_sitemap/API/get_order_list_HTML', (data) => {
    let list = '<ol class="sortable sitemap-order" id="sitemap-order">';
    if (data) {
      if (data.length) {
        list += data;
      }
    }
    list += '</ol>';

    let listEl = jQuery(list);
    jQuery(listEl).hide();
    jQuery('#post-body-content > #order-sitemap > div').prepend(listEl);
    sortListByCurrentSortData();
    jQuery(listEl).show();
    jQuery("#sitemap-order").sortable({
      isValidTarget: function ($item, container) {
        if ($item[0].className.includes('group') && container.el[0].getAttribute('id') !== 'sitemap-order') {
          return false;
        }

        else if ($item[0].className.includes('sub-item') && container.el[0].getAttribute('id') === 'sitemap-order') {
          return false;
        }

        return true;
      }
    });
    document.querySelectorAll('#sitemap-order > li').forEach(li => {
      li.addEventListener('click', function(e) {
        if (this.classList.contains('dragging')) {
          return;
        }

        if (this.classList.contains('opened')) {
          //this.classList.remove('opened');
        } else {
          this.classList.add('opened');
          jQuery(this).prepend('<span class="close-order-list"></span>');
        }
      });
    });

    if (callback) {
      callback();
    }

    
  });
};

//recursive
const getOrderElement = (node) => {

  if (node.firstElementChild) {
    let nodeObj = { ID: node.getAttribute('data-value'), children: [] }
    node.firstElementChild.childNodes.forEach(childNode => {
      nodeObj.children.push(getOrderElement(childNode, nodeObj));
    });
    return nodeObj;
  } else {
    return { ID: node.getAttribute('data-value') };
  }
}

const serializeOrderList = () => {
  let arrayResult = [];
  document.querySelectorAll('#sitemap-order > *').forEach(firstLevelNode => {
    arrayResult.push(getOrderElement(firstLevelNode));
  });

  postRequestJSON('/wp-json/click5_sitemap/API/post_update_list_HTML', arrayResult, (data) => {
    click5_sitemap_notification('success', 'HTML Sitemap order has been updated.');
  });
}

const BTNserializeOrderList = () => {
  let arrayResult = [];

  document.querySelectorAll('#sitemap-order > *').forEach(firstLevelNode => {
    arrayResult.push(getOrderElement(firstLevelNode));
  });

  postRequestJSON('/wp-json/click5_sitemap/API/post_update_list_HTML_save_btn', arrayResult, (data) => {
    //console.log('default order');
  });
}

const reloadOrderList = (callback = undefined) => {
  document.querySelector('#sitemap-order').remove();
  loadOrderList(callback);

  //console.log('reload');
}

const updateEnableCustomHeading = (checkboxElement) => {
  const option_name = checkboxElement.getAttribute('name');
  const option_value = checkboxElement.checked;
  postRequestJSON('/wp-json/click5_sitemap/API/update_option_AJAX', { option_name, option_value, type: 'bool' }, (data) => {
    if (data == true) {
      click5_sitemap_notification('success', 'Settings saved.', 2000);
      reloadOrderList(serializeOrderList);
    }
  });
}

const copyToClipboard = (str) => {
  const el = document.createElement('textarea');
  el.value = str;
  document.body.appendChild(el);
  el.select();
  document.execCommand('copy');
  document.body.removeChild(el);
  click5_sitemap_notification('success', 'Copied to clipboard.', 2000);
}

const resetSitemapOrder = () => {
  postRequestJSON('/wp-json/click5_sitemap/API/reset_sitemap_order', {}, (data) => {
    click5_sitemap_notification('success', 'Default Sitemap order has been applied.', 2000);
    if (data) {
      if (data.length) {
        reloadOrderList(serializeOrderList);
      }
    }
  });

  return true;
}


const TotalresetSitemapOrder = () => {
  postRequestJSON('/wp-json/click5_sitemap/API/total_reset_sitemap_order', {}, (data) => {
    click5_sitemap_notification('success', 'Default Sitemap order has been applied.', 2000);
    if (data) {
      if (data.length) {
        reloadOrderList(serializeOrderList);
      }
    }
  });
}

(() => {
  document.addEventListener("DOMContentLoaded", function (event) {
    if (hasParameter('&tab=seo') || hasParameter('&tab=urls')) {
      return;
    }

    loadOrderList();

    jQuery('body').on('click', 'span.close-order-list', function() {
      jQuery(this).closest('li').removeClass('opened')
      jQuery(this).remove();
    });

    toggleLoader('loader_results', true);
    toggleLoader('loader_blacklisted', true);

  
    let inputSearch = document.querySelector('#page_search');
    let selectType = document.querySelector('#page_type');
    let hiddenAllTypes = document.querySelector('#all_types');

    document.querySelector('#btnSaveOrder').addEventListener('click', function (e) {

      jQuery('span.close-order-list').remove();

      e.preventDefault();
      e.stopPropagation();
      serializeOrderList();
      BTNserializeOrderList();

      if (jQuery('#sitemap-order li.opened').length) {
        jQuery('#sitemap-order li.opened').prepend('<span class="close-order-list"></span>');
      }
    });

    document.addEventListener('click5_sitemap_force_order_list_update', function() {
      reloadOrderList(serializeOrderList);
    });

    document.getElementById('btnClearBlacklist').addEventListener('click', function (e) {
      e.preventDefault();
      e.stopPropagation();

      confirm('Are you sure you want delete all blacklisted pages?');

      getRequest('/wp-json/click5_sitemap/API/clear_blacklist', (data) => {
        if (data == true) {
          document.querySelectorAll('#click5_sitemap_already_blacklisted > li').forEach(el => {
            el.remove();
          });
          //loadBlacklist();
          reloadOrderList(serializeOrderList);
          searchFunc(inputSearch, selectType, hiddenAllTypes);
          this.style.display = 'none';
          click5_sitemap_notification('success', 'Blacklist saved.', 2000);
        } else {
          click5_sitemap_notification('error', 'Something went wrong.', 2000);
        }
      });
    });

    document.getElementById('btnResetOrder').addEventListener('click', function(e) {
      e.preventDefault();
      e.stopPropagation();

      TotalresetSitemapOrder();
    });
    
    document.querySelectorAll('#enableSitemap input[type="checkbox"]').forEach(checkbox => {
      checkbox.addEventListener('change', function(e) {
        updateEnableCustomHeading(this);
        resetSitemapOrder();
      });
    });
    document.querySelectorAll('#enableSitemap select:not(#click5_sitemap_html_blog_group_by)').forEach(checkbox => {
      checkbox.addEventListener('change', function(e) {
        const option_name = this.getAttribute('name');
        const option_value = this.value;
        postRequestJSON('/wp-json/click5_sitemap/API/update_option_AJAX', { option_name, option_value, type: 'text' }, (data) => {
          resetSitemapOrder();
        });
      });
    });

    document.querySelectorAll('#enableSitemap #click5_sitemap_html_blog_group_by').forEach(checkbox => {
      checkbox.addEventListener('change', function(e) {
        const option_name = this.getAttribute('name');
        const option_value = this.value;
        postRequestJSON('/wp-json/click5_sitemap/API/update_option_AJAX', { option_name, option_value, type: 'text' }, (data) => {
          
          if(resetSitemapOrder()){
            window.location.href = window.location.href
          }
          
        });
      });
    });

    document.querySelectorAll('#enableSitemap input[type="number"]').forEach(checkbox => {
      checkbox.addEventListener('change', debounce(function (e) {
        const option_name = this.getAttribute('name');
        const option_value = parseInt(this.value);
        postRequestJSON('/wp-json/click5_sitemap/API/update_option_AJAX', { option_name, option_value, type: 'text' }, (data) => {
          if (data == true) {
            click5_sitemap_notification('success', 'Settings saved.', 2000);
            resetSitemapOrder();
          }
        });
      }, 300));
    });
    document.querySelectorAll('#enableSitemap input[type="text"]').forEach(checkbox => {
      checkbox.addEventListener('input', debounce(function(e) {
        const option_name = this.getAttribute('name');
        const option_value = this.value;
        if (option_value.length) {
          this.previousElementSibling.control.checked = true;
        } else {
          this.previousElementSibling.control.checked = false;
        }

        postRequestJSON('/wp-json/click5_sitemap/API/update_option_AJAX', { option_name, option_value, type: 'text' }, (data) => {
          if (data == true) {
            click5_sitemap_notification('success', 'Settings saved.', 2000);
            updateEnableCustomHeading(this.previousElementSibling.control);
            resetSitemapOrder();
          }
        });
      }, 300));
    });

    loadBlacklist();

    document.addEventListener('blacklist_updated', () => {
      //reloadOrderList(serializeOrderList);
      resetSitemapOrder();
    });

    searchFunc(inputSearch, selectType, hiddenAllTypes);


    selectType.addEventListener('change', function (e) {
      searchFunc(inputSearch, selectType, hiddenAllTypes);
    });
    inputSearch.addEventListener('input', debounce(function (e) {
      searchFunc(inputSearch, selectType, hiddenAllTypes);
    }, 300));

    document.querySelector('#copy-me').addEventListener('click', function(e) {
      e.preventDefault();
      e.stopPropagation();
  
      const toCopy = this.querySelector('strong').innerText.trim();
      copyToClipboard(toCopy);
    });
  });


})();